org.eclipse.jgit.internal.storage.dfs

## Class DfsPackCompactor

- java.lang.Object
- - org.eclipse.jgit.internal.storage.dfs.DfsPackCompactor

    public class DfsPackCompactor
    extends Object

Combine several pack files into one pack.

The compactor combines several pack files together by including all objects contained in each pack file into the same output pack. If an object appears multiple times, it is only included once in the result. Because the new pack is constructed by enumerating the indexes of the source packs, it is quicker than doing a full repack of the repository, however the result is not nearly as space efficient as new delta compression is disabled.

This method is suitable for quickly combining several packs together after receiving a number of small fetch or push operations into a repository, allowing the system to maintain reasonable read performance without expending a lot of time repacking the entire repository.

### Constructor Summary

Constructors
Constructor and Description
`DfsPackCompactor(DfsRepository repository)` Initialize a pack compactor.

### Method Summary

All Methods Instance Methods Concrete Methods
`DfsPackCompactor` `add(DfsPackFile pack)` Add a pack to be compacted.
`DfsPackCompactor` `autoAdd()` Automatically select packs to be included, and add them.
`void` `compact(ProgressMonitor pm)` Compact the pack files together.
`DfsPackCompactor` `exclude(DfsPackFile pack)` Exclude objects from the compacted pack.
`DfsPackCompactor` `exclude(PackWriter.ObjectIdSet set)` Exclude objects from the compacted pack.
`List<DfsPackDescription>` `getNewPacks()`
`List<PackWriter.Statistics>` `getNewPackStatistics()`
`List<DfsPackDescription>` `getSourcePacks()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### DfsPackCompactor

    public DfsPackCompactor(DfsRepository repository)

Initialize a pack compactor.

Parameters:
  `repository` - repository objects to be packed will be read from.

### Method Detail

#### add

    public DfsPackCompactor add(DfsPackFile pack)

Add a pack to be compacted.

All of the objects in this pack will be copied into the resulting pack. The resulting pack will order objects according to the source pack's own description ordering (which is based on creation date), and then by the order the objects appear in the source pack.

Parameters:
  `pack` - a pack to combine into the resulting pack.
Returns:
  `this`

#### autoAdd

    public DfsPackCompactor autoAdd()
                             throws IOException

Automatically select packs to be included, and add them.

Packs are selected based on size, smaller packs get included while bigger ones are omitted.

Returns:
  `this`
Throws:
  `IOException` - existing packs cannot be read.

#### exclude

    public DfsPackCompactor exclude(PackWriter.ObjectIdSet set)

Exclude objects from the compacted pack.

Parameters:
  `set` - objects to not include.
Returns:
  `this`.

#### exclude

    public DfsPackCompactor exclude(DfsPackFile pack)
                             throws IOException

Exclude objects from the compacted pack.

Parameters:
  `pack` - objects to not include.
Returns:
  `this`.
Throws:
  `IOException` - pack index cannot be loaded.

#### compact

    public void compact(ProgressMonitor pm)
                 throws IOException

Compact the pack files together.

Parameters:
  `pm` - progress monitor to receive updates on as packing may take a while, depending on the size of the repository.
Throws:
  `IOException` - the packs cannot be compacted.

#### getSourcePacks

    public List<DfsPackDescription> getSourcePacks()

Returns:
  all of the source packs that fed into this compaction.

#### getNewPacks

    public List<DfsPackDescription> getNewPacks()

Returns:
  new packs created by this compaction.

#### getNewPackStatistics

    public List<PackWriter.Statistics> getNewPackStatistics()

Returns:
  statistics corresponding to the `getNewPacks()`.